<?php
include_once("./repositories/LicencaRepository.class.php");
include_once("./repositories/LicencaAtualizacaoRepository.class.php");
include_once("./repositories/MensagemRepository.class.php");
include_once("./models/Modulos.class.php");
include_once("./models/Inputs.class.php");
include_once("./models/OutPut.class.php");
include_once("./models/OutPutDeErro.class.php");
include_once("./models/Mensagem.class.php");

class PostProcess {
	private static function ObtemInputs() {
		$CorpoJson = json_decode(strtoupper(file_get_contents("php://input")));

		//Passa o corpo para a Classe Inputs
		$Inputs = new Inputs();
		$Inputs->CNPJ = isset($CorpoJson->CNPJ) ? $CorpoJson->CNPJ : "";
		$Inputs->DATA_SERVIDOR = isset($CorpoJson->DATA_SERVIDOR) ? $CorpoJson->DATA_SERVIDOR : "";
		$Inputs->SERIAL_HD = isset($CorpoJson->SERIAL_HD) ? $CorpoJson->SERIAL_HD : "";
		$Inputs->COD_LICENCA = isset($CorpoJson->COD_LICENCA) ? $CorpoJson->COD_LICENCA : 0;
		$Inputs->HTTP_APIKEY = isset($_SERVER['HTTP_APIKEY']) ? $_SERVER['HTTP_APIKEY'] : "";
		
		//Destroi seção caso de algo errado
		if (!$Inputs->IsValid()) {
			new OutputDeErro(400, $Inputs->MensagemDeErro);
		}

		return $Inputs;
	}

	public static function Execute() {
		$Inputs 					= self::ObtemInputs();

		$BuscaCodLicenca			= new LicencaRepository();
		$RetornaCodLicenca 			= $BuscaCodLicenca->GetLicensesBySerial($Inputs->SERIAL_HD,$Inputs->COD_LICENCA);

		$BuscaModulosByCodLicenca	= new LicencaAtualizacaoRepository();
		$RetornaModulosByCodLicenca = $BuscaModulosByCodLicenca->GetModulesByCodLicenca($RetornaCodLicenca->COD_LICENCA);

		$BuscaMensagem				= new MensagemRepository();
		$RetornaMensagem			= $BuscaMensagem->GetLastMessage($RetornaCodLicenca->COD_LICENCA);

		$Liberado  = false;
		$ModulosLib = [];
		foreach($RetornaModulosByCodLicenca as $Modulo){
			if($Modulo->COLUMN_NAME == "FLG_BLOQUEADO"){
				if($Modulo->HABILITADO == "N"){
					$Liberado = true;
				} else {
					$Liberado = false;
				}
				
			}
			if($Modulo->COLUMN_NAME != "FLG_BLOQUEADO"){
				$NovoModulo = new Modulo();
				$NovoModulo->COLUMN_NAME = $Modulo->COLUMN_NAME;
				$NovoModulo->HABILITADO = $Modulo->HABILITADO;
				array_push($ModulosLib ,$NovoModulo);
			}
		}
		//var_dump($Modulo->HABILITADO);

		$output = new OutPut(); 
		$output->LIBERADO       = $Liberado;
		$output->COD_MSG        = $RetornaMensagem->COD_MSG;
		$output->DES_MSG        = $RetornaMensagem->DES_MSG;
		$output->MODULOS        = $ModulosLib;
		$output->DES_MSG_CLI    = $RetornaMensagem->DES_MSG_CLI;

		$output->returnCode(200);;
	}
}

?>